// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITDIFFPARSEOPTIONS_H
#define GITDIFFPARSEOPTIONS_H
#include <nan.h>
#include <string>
#include <utility>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"
#include "worker_pool.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitDiffParseOptions;
 
struct GitDiffParseOptionsTraits {
  typedef GitDiffParseOptions cppClass;
  typedef git_diff_parse_options cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_diff_parse_options **dest, git_diff_parse_options *src) {
     Nan::ThrowError("duplicate called on GitDiffParseOptions which cannot be duplicated");
   }

  static std::string className() { return "GitDiffParseOptions"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_diff_parse_options *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitDiffParseOptions : public
  NodeGitWrapper<GitDiffParseOptionsTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitDiffParseOptionsTraits>;
   public:
    GitDiffParseOptions(const GitDiffParseOptions &) = delete;
    GitDiffParseOptions(GitDiffParseOptions &&) = delete;
    GitDiffParseOptions &operator=(const GitDiffParseOptions &) = delete;
    GitDiffParseOptions &operator=(GitDiffParseOptions &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitDiffParseOptions()
      : NodeGitWrapper<GitDiffParseOptionsTraits>(
           "A new GitDiffParseOptions cannot be instantiated."
       )
    {}
    GitDiffParseOptions(git_diff_parse_options *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitDiffParseOptionsTraits>(raw, selfFreeing, owner)
    {}
    ~GitDiffParseOptions();
    static NAN_METHOD(Version);
    static NAN_METHOD(OidType);
};

#endif
