// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITODBBACKENDPACKOPTIONS_H
#define GITODBBACKENDPACKOPTIONS_H
#include <nan.h>
#include <string>
#include <utility>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"
#include "worker_pool.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitOdbBackendPackOptions;
 
struct GitOdbBackendPackOptionsTraits {
  typedef GitOdbBackendPackOptions cppClass;
  typedef git_odb_backend_pack_options cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_odb_backend_pack_options **dest, git_odb_backend_pack_options *src) {
     Nan::ThrowError("duplicate called on GitOdbBackendPackOptions which cannot be duplicated");
   }

  static std::string className() { return "GitOdbBackendPackOptions"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_odb_backend_pack_options *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitOdbBackendPackOptions : public
  NodeGitWrapper<GitOdbBackendPackOptionsTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitOdbBackendPackOptionsTraits>;
   public:
    GitOdbBackendPackOptions(const GitOdbBackendPackOptions &) = delete;
    GitOdbBackendPackOptions(GitOdbBackendPackOptions &&) = delete;
    GitOdbBackendPackOptions &operator=(const GitOdbBackendPackOptions &) = delete;
    GitOdbBackendPackOptions &operator=(GitOdbBackendPackOptions &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitOdbBackendPackOptions()
      : NodeGitWrapper<GitOdbBackendPackOptionsTraits>(
           "A new GitOdbBackendPackOptions cannot be instantiated."
       )
    {}
    GitOdbBackendPackOptions(git_odb_backend_pack_options *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitOdbBackendPackOptionsTraits>(raw, selfFreeing, owner)
    {}
    ~GitOdbBackendPackOptions();
    static NAN_METHOD(Version);
    static NAN_METHOD(OidType);
};

#endif
