// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITODBOPTIONS_H
#define GITODBOPTIONS_H
#include <nan.h>
#include <string>
#include <utility>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"
#include "worker_pool.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitOdbOptions;
 
struct GitOdbOptionsTraits {
  typedef GitOdbOptions cppClass;
  typedef git_odb_options cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_odb_options **dest, git_odb_options *src) {
     Nan::ThrowError("duplicate called on GitOdbOptions which cannot be duplicated");
   }

  static std::string className() { return "GitOdbOptions"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_odb_options *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitOdbOptions : public
  NodeGitWrapper<GitOdbOptionsTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitOdbOptionsTraits>;
   public:
    GitOdbOptions(const GitOdbOptions &) = delete;
    GitOdbOptions(GitOdbOptions &&) = delete;
    GitOdbOptions &operator=(const GitOdbOptions &) = delete;
    GitOdbOptions &operator=(GitOdbOptions &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitOdbOptions()
      : NodeGitWrapper<GitOdbOptionsTraits>(
           "A new GitOdbOptions cannot be instantiated."
       )
    {}
    GitOdbOptions(git_odb_options *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitOdbOptionsTraits>(raw, selfFreeing, owner)
    {}
    ~GitOdbOptions();
    static NAN_METHOD(Version);
    static NAN_METHOD(OidType);
};

#endif
